#!/usr/bin/env node

/* eslint-disable
  no-console,
  import/extensions,
*/

import generate from './index.js';

const argList = process.argv.join('=').split('=');
let inputPath = null;
let edgeLocaleInclusions = null;
const stores = [];
argList.forEach((item, index) => {
  if (item === '--input' || item === '-i') {
    inputPath = argList[index + 1];
  } else if (item === '--stores' || item === '--store' || item === '-s') {
    stores.push(...argList[index + 1].toLowerCase().split(/[^a-z]/));
  } else if (item === '--edge-locale-inclusions') {
    edgeLocaleInclusions = argList[index + 1].split(',');
  }
});

function logMessageLog (messageLog) {
  messageLog.forEach((message) => {
    console.log(message);
  });
}

generate({
  inputPath,
  stores,
  edgeLocaleInclusions,
}).then(({ messageLog }) => logMessageLog(messageLog))
  .catch((error) => {
    console.error(error);
  });
